Attribute VB_Name = "Subs"
    Option Explicit
    Dim ArMatch() As String
    Dim ArOutlet() As String
    Dim Command1 As String
    Dim Command2 As String
    Dim Cycle As String
    Dim Hold As String

Sub Main()
    Dim i As Integer
    Dim j As Integer
    Dim str1 As String
    Dim Str2 As String
    Dim Ar
    Dim a As Long
    If App.PrevInstance Then End
    On Error GoTo Errortrap
    Hold = "300"
    Cycle = "5"
    Call ReadFile
    Call Log("")
    Call Log("Start", True)
    str1 = Trim(Environ("SA_LONG"))
    If LCase(Trim(Command)) = "test" Then str1 = "The capture device input Hauppauge HD PVR Capture Device #4 Component had a failure while trying to start the recording of ""Aeon Flux"" on TNTHD on physical channel 825 at Sun 9/12 3:30."
    
    If str1 = "" Then
        Call Log("Message is not present")
        End
        Exit Sub
    End If
    Call Log("SageAlert text:")
    Call Log(str1)
    If Command1 <> "" And Command2 <> "" And Cycle <> "" Then
        For i = 1 To UBound(ArMatch)
            If InStr(1, str1, ArMatch(i), vbTextCompare) > 0 Then
                If InStr(1, ArMatch(i), "#", vbTextCompare) > 0 Or InStr(1, str1, "#", vbTextCompare) = 0 Then
                    If IsNumeric(Trim(ArOutlet(i))) Then
                        Str2 = Replace(Command1, "*switchno*", Trim(ArOutlet(i)))
                        Call Log("Sending ""Off"" command to Outlet #" & Trim(ArOutlet(i)), True)
                        Call Log("Command: " & Str2)
                        Call LogShort(ArMatch(i) & " ---  Power Cycle Outlet #" & Trim(ArOutlet(i)))
                        a = Shell(Str2)
                        Call Log("Return code: " & CStr(a))
                        Call Log("Waiting " & Cycle & " sec.", True)
                        Call Pause(Val(Cycle))
                        Str2 = Replace(Command2, "*switchno*", Trim(ArOutlet(i)))
                        Call Log("Sending ""On"" command to Outlet #" & Trim(ArOutlet(i)), True)
                        Call Log("Command: " & Str2)
                        a = Shell(Str2)
                        Call Log("Return code: " & CStr(a))
                        Call Log("Waiting " & Hold & " sec.", True)
                        Call Pause(Val(Hold))
                    Else
                        Call Log("Outlet number is not numeric")
                    End If
                    Exit For
                End If
            End If
        Next
    Else
        Call Log("Command1 or Command2 or Cycle missing")
    End If
    Call Pause(8)
    End
    Exit Sub
Errortrap:
    Log ("Error: " & Err.Description & "on Line " & Erl)
End Sub

Sub ReadFile()
    Dim fs, f, Ar
    Dim str1 As String
    Dim i As Integer
    ReDim ArMatch(0)
    ReDim ArOutlet(0)
    On Error GoTo Errortrap
    i = 0
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.OpenTextFile(App.Path & "\SA.properties", 1, False)
    Do While f.AtEndOfStream <> True
        str1 = Trim(f.ReadLine)
        If Left(str1, 1) <> "#" And InStr(1, str1, "--->", vbTextCompare) > 1 Then
            Ar = Split(str1, "--->")
            If LCase(Ar(0)) = "command1" Then
                Command1 = LCase(Trim(Ar(1)))
            ElseIf LCase(Ar(0)) = "command2" Then
                Command2 = LCase(Trim(Ar(1)))
            ElseIf LCase(Ar(0)) = "cycle" Then
                Cycle = Trim(Ar(1))
            ElseIf LCase(Ar(0)) = "hold" Then
                Hold = Trim(Ar(1))
            Else
                i = i + 1
                ReDim Preserve ArMatch(i)
                ReDim Preserve ArOutlet(i)
                ArMatch(i) = Trim(Ar(0))
                ArOutlet(i) = Trim(Ar(1))
            End If
        End If
    Loop
    f.Close
    Exit Sub
Errortrap:
    Log ("Error: " & Err.Description & "on Line " & Erl)
End Sub

Sub Pause(p As Integer)
    Dim tm As Single
    Dim tm1 As Single
    Dim logit As Boolean
    tm = Timer
    Do While 1 = 1
        tm1 = Timer
        If (tm1 - tm) Mod 10 = 0 Then
            If logit Then Call Log(CStr(Int(p - (tm1 - tm))) & " sec. left", False, False)
            logit = False
        Else
            logit = True
        End If
        If tm1 - tm > p Or tm1 - tm < 0 Then Exit Do
        DoEvents
    Loop
End Sub

Sub Log(msg As String, Optional tm As Boolean = False, Optional fl As Boolean = True)
    Dim fs, f, f1, Ar
    Dim str1 As String
    Dim Str2 As String
    str1 = App.Path & "\SA.log"
    Str2 = msg
    If tm Then Str2 = Format(Now, "mm/dd/yyyy hh:nn:ss AM/PM") & " " & Str2
    Set fs = CreateObject("Scripting.FileSystemObject")
    If fs.fileExists(str1) Then
        Set f1 = fs.getFile(str1)
        If f1.Size > 100000 Then f1.Delete
        Set f1 = Nothing
    End If
    
    If fl Then
        Set f = fs.OpenTextFile(str1, 8, True)
        f.writeline Str2
        f.Close
    End If
End Sub

Sub LogShort(msg As String)
    Dim fs, f, f1, Ar
    Dim str1 As String
    Dim Str2 As String
    str1 = App.Path & "\SAshort.log"
    Str2 = Format(Now, "mm/dd/yyyy hh:nn:ss AM/PM") & " " & msg
    Set fs = CreateObject("Scripting.FileSystemObject")
    If fs.fileExists(str1) Then
        Set f1 = fs.getFile(str1)
        If f1.Size > 100000 Then f1.Delete
        Set f1 = Nothing
    End If
    
    Set f = fs.OpenTextFile(str1, 8, True)
    f.writeline Str2
    f.Close
End Sub

